#!/bin/bash
## ===========================================================================================================
## livestream-aufnahme.sh - &copy Stefan Bürger, www.stefan-buerger.de
## Script zur direkten Aufnahmeprogrammierung
## 
## Nur für LINUX bash...
## livestream-vlc.sh: ........ Livestreams der öffentlich-rechtlichen Mediatheken in VLC ansehen
## ........................... Parameter: Sender (ard, zdf, rbb, rbb-brb, mdr, ndr, wdr,swr, hr, br, sr, neo, 3sat, arte, info, 
## ........................... .................. phoenix, alpha, one, tagesschau, kika, orf1, orf2, orf3, orf-sport, arte-fr)
## ........................... Speicherort: beliebiges Benutzerverzeichnis, verwendet livestream-adresse.inc
## filmschnitt.sh:............ Videodatei schneiden und konvertieren (möglichst nach MP4 1280x720)
## ........................... Parameter: [HDfull|HDready|DVD|Android] Videodatei [Startzeit(hh:mm:ss) [Stopzeit(hh:mm:ss) [FPSx1000 Audiooffset]]]
## ........................... Speicherort: beliebiges Benutzerverzeichnis, verwendet livestream-adresse.inc
## livestream-aufnahme.sh:.... Livestreams der öffentlich-rechtlichen Mediatheken zeitgesteuert aufnehmen/speichern
## ........................... Parameter: Sender(wie bei livestream-vlc.sh) Startzeit(YYYYMMDDhhmm) Dauer(mmm) Name
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/), 
## ........................... ............ verwendet livestream-adresse.inc, livestream-aufnahme.sh, livestream-aufnahme-rm.sh
## livestream-aufnahme-pre.sh: Livestreams der öffentlich-rechtlichen Mediatheken aus TVbrowser zeitgesteuert aufnehmen/speichern
## ........................... Parameter: [remove] Sender(wie bei livestream-vlc.sh, Jahr Monat Tag Stunde Minute Dauer Name
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/), verwendet livestream-adresse.inc
## livestream-aufnahme-rm.sh:. Programmierte Aufnahme löschen
## ........................... Parameter: Sender(wie bei livestream-vlc.sh) Startzeit(YYYYMMDDhhmm) Dauer(mmm) Name
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/), verwendet livestream-adresse.inc
## livestream-adresse.inc:.... Senderliste für  die bash-Scripte
## ........................... Speicherort: Benutzer-Homeverzeichnis (~/)
## 
## Pfad-Festlegungen:
##     
## 
scriptversion=3.0
scriptdatum=22.11.2023
## ===========================================================================================================
## Script zur Programmierung von Sendungsaufzeichnungen aus Mediatheken der in Deutschland abrufbaren öffentlich-rechtlichen Sender
## Die Aufnahmezeitsteuerung erfolgt mit at.
## Für jede Aufzeichnung wird ein Startscript "<Name>.sh" für den at-Aufruf und ein Hilfsscript "<Name>_ex.sh" erzeugt, mit dem 
## at der eigentliche Aufzeichnungsstart ermöglicht wird. Diese Konstruktion ermöglicht auch die spätere Löschung des Auftrags mit
## dem Script "<Name>_rm.sh". 
## 
## $1: Sender    ard, zdf, rbb, rbb-brb, mdr, ndr, wdr,swr, hr, br, sr, neo, 3sat, arte, phoenix, info, alpha, one, tagesschau, kika
## $2: Startzeit '[[[[YYYY]MM]DD]hh]mm'
## $3: Dauer     'mm'
## $4: Name
##
## Hinweis: Die Bearbeitungskonstrukte erscheinen teilweise etwas umständlich, sind aber in bash ohne zusätzliche Sprachelemente nutzbar.
## 

source ~/livestream-adresse.inc

if [ -z $4 ]; then
    storename=livestream
else
    storename=$4
fi
storename=$(echo $storename | zeichenersetzen)
startzeitm=$(($2%100))
startzeith=$(($2/100))
startzeith=$(($startzeith%100))
startzeitD=$(($2/10000))
startzeitD=$(($startzeitD%100))
startzeitM=$(($2/1000000))
startzeitM=$(($startzeitM%100))
startzeitY=$(($2/100000000))
startzeit="${startzeitY}-${startzeitM}-${startzeitD}_${startzeith}-${startzeitm}"
dauerh=$(($3/60))
dauerm=$(($3%60))
dauer=$dauerh:$dauerm:00
for ((index=0;index<${#streamaddr[@]};index+=$streamaddrsize))
do
    if [ "$1" = "${streamaddr[$index]}" ]
    then
        echo "\"$1\" - \"${streamaddr[$index]}\""
        tmpidx=$(($index/$streamaddrsize))
        echo livestream-aufnahme.sh: Aufnehmen - $datum_zeit - $tmpidx Sender=${streamaddr[$index]} Stream=${streamaddr[$index+$idxStreamaddr]} Name=${storename} Start=$2 Dauer=$3 >> $aufnahmepfad_absolut${logpfad_relativ}livestream-aufnahme.log
        echo "Aufnehmen: $tmpidx Sender=${streamaddr[$index]}-HD, Stream=${streamaddr[$index+$idxStreamaddr]}, Name=${storename}, Start=$2, Dauer=$3m\n" >> $aufnahmepfad_absolut${logpfad_relativ}livestream-aufnahme.log
        # erzeuge ffmpeg exec script
        echo nice -n 0 ffmpeg -i ${streamaddr[$index+$idxStreamaddr]} -t $dauer $aufnahmepfad_absolut${storename}_${streamaddr[$index]}-HD_${startzeit}_$3.mp4 >  $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh
        echo rm -f $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2.sh                                            >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh
        echo rm -f $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh                                         >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh
        echo rm -f $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_rm.sh                                         >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh
        # verschieben nach NAS_mp4
        if [ -d $ablagepfad_absolut ]; then
            # echo mv $aufnahmepfad_absolut${storename}_${streamaddr[$index]}-HD_${startzeit}_$3.mp4 $ablagepfad_absolut                         >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh
            echo mv $aufnahmepfad_absolut*.mp4 $ablagepfad_absolut                                                                             >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh
        fi
        # erzeuge aufrufendes script für "at" Kommando (nötig, damit remove funktioniert), nur dieses script steht permanent im "at" queue!
        echo sh $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh                                            >  $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2.sh
        #sleep 1s
        atq > $aufnahmepfad_absolut$scriptpfad_relativ./pre.txt
        # at -t $2 -m -f -q ${streamaddr[$index+$idxSenderprio]} $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2.sh
        at -t $2 -m -f $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2.sh
        sleep 1s
        atq > $aufnahmepfad_absolut$scriptpfad_relativ./post.txt
        #echo -e "***** \n'$aufnahmepfad_absolut' '$scriptpfad_relativ' '${storename}' '${streamaddr[$index]}' '$2'***** \n$(cat $aufnahmepfad_absolut$scriptpfad_relativ./pre.txt)\n***** \n$(cat $aufnahmepfad_absolut$scriptpfad_relativ./pre.txt)\n***** "
        diff $aufnahmepfad_absolut$scriptpfad_relativ./pre.txt $aufnahmepfad_absolut$scriptpfad_relativ./post.txt | grep \> | cut -c3-7 | sed -e "s/[a-zA-Z]//g" > at_id.txt
        at_id=$(cat ./at_id.txt)
        echo "$at_id"
        rm $aufnahmepfad_absolut${scriptpfad_relativ}pre.txt
        rm $aufnahmepfad_absolut${scriptpfad_relativ}post.txt
        rm ./at_id.txt
        echo atrm $at_id                                                                                                                  >  $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_rm.sh       
        echo rm -f $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2.sh                                       >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_rm.sh
        echo rm -f $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_ex.sh                                    >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_rm.sh
        echo rm -f $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_rm.sh                                    >> $aufnahmepfad_absolut$scriptpfad_relativ${storename}_${streamaddr[$index]}_$2_rm.sh
    fi
done

#atq

unset streamaddr
unset storename
unset duration
unset durationh
unset durationm
unset tmpidx

