#!/bin/bash

source $HOME/livestream-adresse.inc

mypath="$(pwd ./)/" 
extstr="_$(date +'%Y-%m-%d_%H-%M-%S')"

if [ -z $1 ]; then
  p1="komplett"
else
  p1=$1
fi
extstr="_$p1$extstr"
verstxt="# 'loop_filmschnitt.sh' - V1.47 - 01.05.2024 - Erzeugtes Script: \"${mypath}convloop$extstr.sh\"\n# ... erzeugt Script mit Liste der im Verzeichnis gefundenen Videodateien\n# Parameter:\n#  *  \$1           =schneiden/konvertieren (<default>)/low/dvd/web_vp9/web_av1/komplett/umbenennen,\n#  *  \$2 (optional)=Leistungswert [15...100|max|min],\n#  *  \$3 (optional)=Namenfilter/Unterverzeichnis, z.B. \"Test\"\n# Die Parameter \$2 und \$3 können im Aufruf auch getauscht werden.\n# Für die gefundenen Videodateien wird ein Aufruf mit den erforderlichen Parametern - ggf. Defaults ändern - erzeugt.\n# "

# === Standard-Video-Zielcodecformat
#vCodec="-h264"
vCodec="-hevc"
#vCodec="-vp9"
#vCodec="-av1"

# === Standard-Video-Zielauflösung
#vFormat=""        # (default)
#vFormat="-low"   #-272p / -android / -m android             #(480x272)
#vFormat="-dvd"   #-480p / -m dvd / -m 480p                  #(720x480)
vFormat="-high"  #-720p / -hdready / -m hdready / -m 720p   #(1280x720)
#vFormat="-max    #-1080p" / -hdfull / -m hdfull / -m 1080p  #(1920x1080)

# === Standard-Audioo-Zielcodecformat
#aCodec="-aac"
#aCodec="-eac3"
#aCodec="-ac3"
#aCodec="-opus"
aCodec="-acopy"

bkupSel="" #" -pfad1 '<neuer Zielpfad>' -pfad2 '<neuer Zielpfad>' -pfad3 '<neuer Zielpfad>' -bkup1 '<neuer Zielpfad>' -bkup2 '<neuer Zielpfad>' -bkup3 '<neuer Zielpfad>' -nobkup1 -nobkup2 -nobkup3"

# === Standard-Audiostream-Auswahl
aSelect=""
#aSelect="-s allaudio"
#aSelect="-s audio1"
#aSelect="-s audio2"
#aSelect="-s audio3"

zusatzCmd=" -zo ' -y'"
#zusatzCmd="-l"

# =========================================
# === nachfolgende Teile nicht verändern...
#
#  V1.8a-d:      Hilfsfunktionen für Ausführungsverzögerung
#  V1.8e-f:      Reihenfolge der Einträge im Zielscript geändert, um das Ampassen der Einzelwerte zu erleichtern (kopierbare Verzeichnisvorschläge nun direkt über Bearbeitungsliste)
#  V1.8g-h/V1.9: Feintuning, Korrektur der Wildcard-Behandlung
#  V1.10 ...:    Weitere Abkürzungsoptionen low und dvd, Optimierungen
#

echo -e "$verstxt"

[ -z $1 ] && echo -e "# Kein Parameter gefunden, Default-Liste 'komplett' wird erzeugt"

if [ "$2" = "" ]; then
  p2= ; p3=""
elif [ "${2%[_|-|0|a-z|A-Z][_|-|a-z|A-Z]*}" != "" ]; then
  p3=$2
  if [ -z $3 ]; then
    p2=0
  elif [ $3 -ge 15 -a $3 -le 100 ] || [ "$3" == "max" ] || [ "$3" == "min" ]; then
    p2=$3
  else
    p2=0
  fi
elif [ $2 -ge 15 -a $2 -le 100 ] || [ "$2" == "max" ] || [ "$2" == "min" ]; then
  p2=$2
  if [ "$3" = "" ]; then
    p3=""
  elif [ "${3%[_|-|0|a-z|A-Z][_|-|a-z|A-Z]*}" != "" ]; then
    p3=$3
  else
    p3=""
  fi
else
  p2=0 ; p3=""
fi

echo -e "# Aktion (schneiden/konvertieren ({(Standard)|copy|low|web_vp9|web_av1|dvd|dvd_dup})/komplett/umbenennen) = \"$p1\""
[ "$p2" = "" ] && echo -e "# Default-Konvertierleistung" || echo -e "# Konvertierleistung = $p2%"
[ "$p3" = "" ] && echo -e "# kein Namenfilter" || echo -e "# Parameter 3: Namenfilterzusatz (z.B. alle Namen anfangend mit \"TEST\") = \"$p3\""
echo -e "#!/bin/bash\n\n$verstxt\n# Konvertierliste erzeugt am $(date +'%d.%m.%Y %H:%M')\n# \n# Parameter 1: Aktion (schneiden/konvertieren/komplett/umbenennen) = \"$p1\"" >> "${mypath}convloop$extstr.sh"
[ "$p2" = "" ] && echo -e "# Default-Konvertierleistung" >> "${mypath}convloop$extstr.sh"
[ "$p2" = "" ] || echo -e "# Parameter 2: Konvertierleistung = $p2%" >> "${mypath}convloop$extstr.sh"
[ "$p3" = "" ] || echo -e "# Parameter 3: Namenfilterzusatz (z.B. alle Namen anfangend mit \"TEST\") = \"$p3\"" >> "${mypath}convloop$extstr.sh"

echo -e "source $HOME/livestream-adresse.inc" >> "${mypath}convloop$extstr.sh"

echo "function Sub1 { # \$1=<Stunde 0...23>:<Minute 0...59>" >> "${mypath}convloop$extstr.sh"
echo "  local HM=\$(( \$(( \$(( \${1%%:*} % 24 )) * 60 )) + \$(( \${1##*:} % 60 )) )) ; echo \$HM " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo "function es_ist_nach { # \$1=<Stunde 0...23>:<Minute 0...59>, optional [\$2=\"Befehl JA\" und \$3=\"Befehl NEIN\"] oder return 1, bzw. 0" >> "${mypath}convloop$extstr.sh"
echo "  local H1=\$(Sub1 \"\$1\") ; local H2=\$(date | awk 'END {print (\$4)}') ; H2=\$(Sub1 \${H2%%:*})" >> "${mypath}convloop$extstr.sh"
echo "  if [ \$H1 -lt \$H2 ]; then if [ \"\$2\" == \"\" ]; then return 1 ; else \$2 ; fi ; else if [ \"\$3\" == \"\" ]; then return 0 ; else \$3 ; fi ; fi " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo "function es_ist_vor { # \$1=<Stunde 0...23>:<Minute 0...59>, optional [\$2=\"Befehl JA\" und \$3=\"Befehl NEIN\"] oder return 1, bzw. 0" >> "${mypath}convloop$extstr.sh"
echo "  local H1=\$(Sub1 \"\$1\") ; local H2=\$(date | awk 'END {print (\$4)}') ; H2=\$(Sub1 \${H2%%:*})" >> "${mypath}convloop$extstr.sh"
echo "  if [ \$H1 -ge \$H2 ]; then if [ \"\$2\" == \"\" ]; then return 1 ; else \$2 ; fi ; else if [ \"\$3\" == \"\" ]; then return 0 ; else \$3 ; fi ; fi " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo "function es_ist_zwischen { # \$1=<Stunde 0...23>:<Minute 0...59>, \$2=<Stunde 0...23>:<Minute 0...59>, optional [\$3=\"Befehl JA\" und \$4=\"Befehl NEIN\"] oder return 1, bzw. 0" >> "${mypath}convloop$extstr.sh"
echo "  local H1=\$(Sub1 \"\$1\") ; local H2=\$(Sub1 \"\$2\") ; local H3=\$(date | awk 'END {print (\$4)}') ; H3=\$(Sub1 \${H3%%:*})" >> "${mypath}convloop$extstr.sh"
echo "  if [ \$H1 -lt \$H3 -a \$H2 -ge \$H3 ]; then if [ \"\$3\" == \"\" ]; then return 1 ; else \$3 ; fi ; else if [ \"\$4\" == \"\" ]; then return 0 ; else \$4 ; fi ; fi " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo "function es_ist { # \$1=<Name des Tages (\"date +%A\")> [\$2=\"Befehl JA\" und \$3=\"Befehl NEIN\"] oder return 1, bzw. 0" >> "${mypath}convloop$extstr.sh"
echo "  local D1=\$(date +%A) ; local D2a=\$1 ; local D2b=\$1 ; D2a=\"\${D2a:0:1}\" ; D2a=\"\${D2a^^}\" ; D2b=\"\${D2b:1}\" ; D2b=\"\${D2b,,}\"" >> "${mypath}convloop$extstr.sh"
echo "  if [ \"\$D1\" == \"\$D2a\$D2b\" ]; then if [ \"\$2\" == \"\" ]; then return 1 ; else \$2 ; fi ; else if [ \"\$3\" == \"\" ]; then return 0 ; else \$3 ; fi ; fi " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo "function schlafe_bis { # \$1=<Stunde 0...23>:<Minute 0...59>" >> "${mypath}convloop$extstr.sh"
echo "  local H1=\$(( \${1%%:*} % 24 )) ; local M1=\$(( \${1##*:} % 60 )) ; M1=\$(( \$(( \$M1 - \$(date +%-M) )) % 60 ))" >> "${mypath}convloop$extstr.sh"
echo "  if [ \$M1 -lt 0 ]; then H1=\$(( \$H1 - 1 )) ; M1=\$(( \$M1 + 60 )) ; fi" >> "${mypath}convloop$extstr.sh"
echo "  H1=\$(( \$(( \$H1 + 24 - \$(date +%-H) )) % 24 )) ; local H2=\$(( \$(( \$H1 + \$(date +%-H) )) % 24 )) ; local M2=\$(( \$M1 + \$(date +%-M) ))" >> "${mypath}convloop$extstr.sh"
echo "  if [ \$M2 -ge 60 ]; then H2=\$(( \$H2 + 1 )) ; M2=\$(( \$M2 - 60 )) ; fi ; if [ \$M1 -lt 0 ]; then H1=\$(( \$H1 - 1 )) ; M1=\$(( \$M1 + 60 )) ; fi" >> "${mypath}convloop$extstr.sh"
echo "  echo -e \"\\033[0;37m\\033[41mFortsetzung um \$(printf '%02d' \$H2):\$(printf '%02d' \$M2) (in \$H1:\$(printf '%02d' \$M1) Stunden)\\033[0m\\033[25m\" ; sleep \${H1}h ; sleep \${M1}m ; date " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo "function warte_auf_Konvertierung { # \$1='<Name/Namenteil>'" >> "${mypath}convloop$extstr.sh"
echo "  echo -e \"\\033[0;37m\\033[41mWarte auf Ende anderer Konvertierung (Datei \"*$1*\"\\033[0m\\033[25m\" ; while [ \$(lsof +d $PWD/* | grep -iE \"\$1\" | grep -iEc 'ffmpeg') -gt 0 ]; do sleep 30; done " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo "function shutdown { # \$1=<Stunde 0...23>:<Minute 0...59>" >> "${mypath}convloop$extstr.sh"
echo "  echo -e \"\\033[0;37m\\033[41mAchtung: 'shutdown' benötigt sudo-Berechtigung!\n=> 'sudo visudo' => '%group_name ALL=(ALL) NOPASSWD: /sbin/shutdown'\\033[0m\\033[25m\"; /sbin/shutdown -h \$1 " >> "${mypath}convloop$extstr.sh"
echo "  }" >> "${mypath}convloop$extstr.sh"

echo -e "#
#  $HOME/filmschnitt.sh [-subdir '<Verzeichnis>'|-schneiden|-umbenennen|-verschieben] [-h264|-hevc|-vp9|-av1] [-272p|...|-720p|-1080p|-2160p] -i '<Name>' [-a <Start>] [-e <Ende>]
#      '[[/]../]<Zielverzeichnis>' ist relativ zum in 'filmschnitt.sh - \$bkup[1|2|3]dir' festgelegten Pfad! Mit dem ersten Zeichen '/' muss '<Zielverzeichnis>' existieren, es wird nicht neu angelegt.
#      mit '../' wird das Zielverzeichnis im übergeordneten Verzeichnis von '\$bkup[1|2|3]dir' verwendet. Alternativ kann das Anlegen von zwei Verzeichnisebenen gesteuert werden:
#          \"-subdir '[/][../]<Zielverzeichnis>/<Unterverzeichnis>'\" oder \"-subdir '[/][../]<Zielverzeichnis>' '[/]<Unterverzeichnis>' ist möglich." >> "${mypath}convloop$extstr.sh"

echo -e "$($HOME/filmschnitt.sh -zeigePfade $p1)" >> "${mypath}convloop$extstr.sh"

echo -e "#  --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#  Beispiele für \"filmschnitt.sh\"-Aufrufe:
#      /home/stefan/filmschnitt.sh -schneiden -i './<Videoquelle>' -a [<Start H:MM:SS>] [-e <Ende H:MM:SS>]
#      /home/stefan/filmschnitt.sh [-subdir '<Zielverzeichnis>'] -acopy -copy -i './<Videoquelle>' [-a <Start H:MM:SS>] [-e <Ende H:MM:SS>]
#      /home/stefan/filmschnitt.sh [-subdir '<Zielverzeichnis>'] -aac -hevc -high -i './<Videoquelle>' [-a <Start H:MM:SS>] [-e <Ende H:MM:SS>]
#      /home/stefan/filmschnitt.sh -umbenennen -i './<Videoquelle>' 
#      /home/stefan/filmschnitt.sh -verschieben '<Zielverzeichnis>' -i './<Videoquelle>'" >> "${mypath}convloop$extstr.sh"

echo -e "#  --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#  Hilfsfunktionen für zeitabhängige Verarbeitung (z.B. Medium zeitweise nicht erreichbar):
#      es_ist_nach <h>:<m> [[\"<JA>\"] [\"<NEIN>\"]] / es_ist_vor <h>:<m> [[\"<JA>\"] [\"<NEIN>\"]]       Beispiele: 'es_ist_nach 7:15 \"echo JA\" \"echo NEIN\"', 'es_ist_vor 23:59 \"echo JA\" \"echo NEIN\"'
#      es_ist_zwischen <h>:<m> <h>:<m> [[\"<JA>\"] [\"<NEIN>\"]]                                      Beispiel: 'es_ist_zwischen 7:15 22:59 \"echo JA\" \"echo NEIN\"'
#      es_ist <Sonntag|...|Samstag> [[\"<JA>\"] [\"<NEIN>\"]]                                         Beispiel: 'es_ist Montag \"echo JA\" \"echo NEIN\"'
#      schlafe_bis <h>:<m> / warte_auf_Konvertierung <Name/Namenteil> / shutdown [<h>:<m>|now]    Beispiele: 'schlafe_bis 7:15', 'warte_auf_Konvertierung \"Metropolis\"', 'shutdown now'
#  --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#  Besondere Verzeichnisse '[/][../]00[0-9][0-9]*': | '../0000_Mediathekview'           | '0001_Musik'                      | '0002_Klassik_Oper_Theater'       | '../0004_Maerchen/Kinder_bis_12J' |
#                                                   | '../0004_Maerchen/Kinder_ab_12J'  | '0005_Cartoon_Anime'              | '0006_Stummfilme_bis_1930'        | '0009_Android'                    |
#  --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
" >> "${mypath}convloop$extstr.sh"

zeitmarken=""

if [ "$p3" != "" ]; then
  if [ "${p3:0:1}" != "\*" ] && [ "${p3: -1}" != "\*" ] && [ "${p3:0:1}" != "*" ] && [ "${p3: -1}" != "*" ]; then
    subdir=$p3
    p3=
  else
    subdir=
  fi
else
  subdir=
fi
if [ -z $p2 ] || [ $p2 -eq 0 ]; then
  p2x=""
  p2="default"
else
  p2x=" -p $p2"
fi

if [ -z $p1 ]; then
  defop="komplett"
elif [ "${p1,,}" = "schneiden" ] || [ "${p1,,}" = "komplett" ]; then
  # Schneiden (Original wird verschoben)
  defop="${p1,,}"
  zeitmarken=" -a 0 -e 0"
elif [ "${p1,,}" = "konvertieren" ] || [ "${p1,,}" = "umbenennen" ]; then
  # In Standard-Format konvertieren bzw. Datei gem. Namenregel umbenennen
  defop="${p1,,}"
else
  defop="konvertieren"
  case "${p1,,}" in
    "copy")     subdir="$subdir"             ;vCodec="-copy"   ;vFormat="";zeitmarken="" ;;
    "android")  subdir="0010_Android/$subdir";vCodec="-h264"   ;vFormat="-low";zeitmarken="" ;;
    "low")      subdir="$subdir"             ;vCodec="-hevc"   ;vFormat="-low";zeitmarken=" -a 0 -e 0" ;;
    "low_h264") subdir="0010_Android/$subdir";vCodec="-n -h264";vFormat="-low";zeitmarken="" ;;           # Klon erstellen, Original bleibt im Quellenverzeichnis
    "low_hevc") subdir="0010_Android/$subdir";vCodec="-n -hevc";vFormat="-low";zeitmarken="" ;;           # Klon erstellen, Original bleibt im Quellenverzeichnis
    "dvd")      subdir="$subdir"             ;vCodec="-hevc"   ;vFormat="-dvd";zeitmarken=" -a 0 -e 0" ;;
    "dvd_h264") subdir="0011_DVD/$subdir"    ;vCodec="-n -hevc";vFormat="-dvd";zeitmarken="" ;;           # Klon erstellen, Original bleibt im Quellenverzeichnis
    "dvd_hevc") subdir="0011_DVD/$subdir"    ;vCodec="-n -hevc";vFormat="-dvd";zeitmarken="" ;;           # Klon erstellen, Original bleibt im Quellenverzeichnis
    "web_vp9")  subdir="0013_WEB/$subdir"    ;vCodec="-n -vp9" ;vFormat="-low";zeitmarken="" ;;           # Klon erstellen, Original bleibt im Quellenverzeichnis
    "web_av1")  subdir="0013_WEB/$subdir"    ;vCodec="-n -av1" ;vFormat="-low -l";zeitmarken="" ;;        # Klon erstellen, Original bleibt im Quellenverzeichnis
    *)          subdir=""                    ;vCodec="-hevc"   ;vFormat="-high";zeitmarken=" -a 0 -e 0";;
  esac
fi


if [ "${p1,,}" = "web_vp9" ]; then
  # Klon in LOW-Format/VP9 erstellen, Original bleibt im Quellenverzeichnis
  defop="konvertieren"
  subdir="0013_WEB/$subdir"
  zeitmarken=""
  vCodec="-n -vp9"
  aCodec="-opus"
  vFormat="-low"
elif [ "${p1,,}" = "web_av1" ]; then
  # Klon in LOW-Format/AV1 erstellen, Original bleibt im Quellenverzeichnis
  defop="konvertieren"
  subdir="0013_WEB/$subdir"
  zeitmarken=" -l"
  vCodec="-n -av1"
  aCodec="-opus"
  vFormat="-low"
else
  defop="komplett"
fi

function liste_erstellen {
  # Parameter 1: Videodateiname-Erweiterung (.ts, .m2t,, .avi, -mpg, .mp4, .mkv, .webm)
  # globaler Parameter \$p2 / \$p2x: Konvertierleistung
  # globaler Parameter \$p3: Namenfilterzusatz (z.B. alle Namen anfangend mit "TEST")
  # globaler Parameter \$subdir: Unterverzeichnis
  # globaler Parameter \$defop: Aktionsauswahl
  echo -e  -n "\033[47m\033[30m*$1, \033[0m\033[25m"
  if [ "$defop" == "schneiden" ]; then
    find ./ -mindepth 1 -maxdepth 1 -wholename "$p3*$1" -exec echo "#$HOME/filmschnitt.sh -schneiden $bkupSel $p2x $zusatzCmd $zeitmarken -i '{}' " >> "${mypath}convloop$extstr.tmp" \;
  elif [ "$defop" == "konvertieren" ] || [ "$defop" == "komplett" ]; then
    find ./ -mindepth 1 -maxdepth 1 -wholename "$p3*$1" -exec echo "#$HOME/filmschnitt.sh -subdir '$subdir' $bkupSel $aCodec $aSelect $vCodec $vFormat $p2x $zusatzCmd $zeitmarken -i '{}' " >> "${mypath}convloop$extstr.tmp" \;
  elif [ "$defop" == "umbenennen" ]; then
    #find ./ -mindepth 1 -maxdepth 1 -wholename "$p3*$1" -exec echo "#$HOME/filmschnitt.sh -umbenennen -i '{}' " >> "${mypath}convloop$extstr.tmp" \;
    find ./ -mindepth 1 -maxdepth 1 -wholename "$p3*$1" -exec echo "$HOME/filmschnitt.sh -umbenennen -i '{}' " >> "${mypath}convloop$extstr.tmp" \;
  elif [ "$defop" == "verschieben" ]; then
    find ./ -mindepth 1 -maxdepth 1 -wholename "$p3*$1" -exec echo "#mv  '{}' '$subdir/'" >> "${mypath}convloop$extstr.tmp" \;
  fi
}

echo "" > "${mypath}convloop$extstr.tmp"
liste_erstellen ".ts" ; liste_erstellen ".m2t" ; liste_erstellen ".avi" ; liste_erstellen ".mpg" ; liste_erstellen ".mp4" ; liste_erstellen ".mkv" ; liste_erstellen ".webm" #; liste_erstellen ".???"

[ "$aCodec" == "" ] && aCodec="default"
[ "$aSelect" == "" ] && aSelect="default"

echo -e "\033[0m\033[25m\n\033[47m\033[30m\$p2='$p2' | \$p3='$p3' | \$defop='$defop' | \$bkupSel='$bkupSel' | \$subdir='$subdir' | \$vCodec='$vCodec' | \$vFormat='$vFormat' | \$aCodec='$aCodec' | \$aSelect='$aSelect' | \$zusatzCmd='$zusatzCmd'\033[0m\033[25m"

echo -e -n "\n# Liste der gefundenen Videodateien, Parameter bei Bedarf anpassen und '#' am Zeilenanfang zur Aktivierung entfernen...\n\n#\$(cat /home/stefan/Multimedia/DVBT-Aufnahme/tmp-log/filmschnitt.log)\n\ncd $mypath" >> "${mypath}convloop$extstr.sh"
sort "${mypath}convloop$extstr.tmp" | sed -e 's/   / /g;s/   / /g;s/  / /g' >> "${mypath}convloop$extstr.sh"
[ -d "${mypath}XXX_Konvertierte_Quellen/" ] || mkdir "${mypath}XXX_Konvertierte_Quellen/"
subpath="XXX_Konvertierte_Quellen/"
echo -e "\nmv ${mypath}convloop$extstr.sh $mypath${subpath}convloop$extstr.sh\necho -e \"\$SETBGWW\$SETBLD\$TRENNER\$SETBGSW\$NOCOL\\\n\$SETBGWW\$SETBLD\$TRENNER\$SETBGSW\$NOCOL\\\n\$SETBGWW\$SETBLD\$TRENNER\$SETBGSW\$NOCOL\\\n\\\n\"" >> "${mypath}convloop$extstr.sh"
rm "${mypath}convloop$extstr.tmp"
chmod +x "${mypath}convloop$extstr.sh"
